diff --git a/src/backend/access/transam/xlog.c b/src/backend/access/transam/xlog.c
index 977d448f50..d238ccb814 100644
--- a/src/backend/access/transam/xlog.c
+++ b/src/backend/access/transam/xlog.c
@@ -12421,6 +12421,9 @@ PromoteIsTriggered(void)
 	 */
 	if (LocalPromoteIsTriggered)
 		return true;
+	
+	if(!XLogCtl->SharedPromoteIsTriggered)
+		CheckForStandbyTrigger();
 
 	SpinLockAcquire(&XLogCtl->info_lck);
 	LocalPromoteIsTriggered = XLogCtl->SharedPromoteIsTriggered;
